/* MainController */

#import <Cocoa/Cocoa.h>

@interface MainController : NSObject
{
	IBOutlet NSWindow*    mainWin;
	
	IBOutlet NSTextField* appPath;
    IBOutlet NSImageView* appIcon;
	
	IBOutlet NSTextField* newPath;
    IBOutlet NSImageView* newIcon;
	
    IBOutlet NSButton*    restoreButton;
    IBOutlet NSButton*    commitButton;
	
	BOOL havePatchableApplication;
	BOOL hasNewIcon;
	
	NSString* sIconFilePath;
	
	NSString* iconFilePath;
	NSString* newIconFilePath;
	NSString* inspectedAppPath;
	NSImage* notPatchableImage;
	
}
- (IBAction)commit:(id)sender;
- (void)doCommit;

- (IBAction)restoreIcon:(id)sender;
- (void)doRestore;

- (IBAction)onIconChange:(id)sender;
- (IBAction)onPathChange:(id)sender;

- (NSString *)getApplicationIconPath;
- (NSString *)getBackupIconFilePath;

- (void)setApplicationPath:(NSString *)path;
- (void)setApplication:(NSString *)path;
- (void)refreshSetApplication;

- (void)setTheIconPath:(NSString *)path;
- (void)setTheIcon:(NSString *)path;

- (void)inspectApplication:(NSString *)path;
- (void)alert:(NSString *)msg details:(NSString *)detailedMsg importance:(int)imp;

- (void)refreshCommitButtonAvailability;
- (void)refreshRestoreButtonAvailability;

- (BOOL)_openFile:(NSString *)filePath;

// NSAlert delegate
- (void)alertDidEnd:(NSAlert *)alert returnCode:(int)returnCode contextInfo:(void *)contextInfo;

// mainWin delegate method
- (void)windowWillClose:(NSNotification *)aNotification;

// application delegate method
- (BOOL)application:(NSApplication *)app openFile:(NSString *)filePath;
- (void)application:(NSApplication *)app openFiles:(NSArray *)filePaths;

@end
